Libargus API Libargus Camera API

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
BlockingSessionCameraProvider.h
Go to the documentation of this file.
1 /*
2 * Copyright (c) 2021, NVIDIA CORPORATION. All rights reserved.
3 *
4 * Redistribution and use in source and binary forms, with or without
5 * modification, are permitted provided that the following conditions
6 * are met:
7 * * Redistributions of source code must retain the above copyright
8 * notice, this list of conditions and the following disclaimer.
9 * * Redistributions in binary form must reproduce the above copyright
10 * notice, this list of conditions and the following disclaimer in the
11 * documentation and/or other materials provided with the distribution.
12 * * Neither the name of NVIDIA CORPORATION nor the names of its
13 * contributors may be used to endorse or promote products derived
14 * from this software without specific prior written permission.
15 *
16 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS ``AS IS'' AND ANY
17 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
19 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
20 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
21 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
22 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
23 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
24 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
25 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
26 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
27 */
28
29 /**
30 * @file
31 * <b>Libargus Extension: Blocking Session Capture Provider API</b>
32 *
33 * @b Description: This file defines the BlockingSessionCaptureProvider extension.
34 */
35
36 #ifndef _ARGUS_BLOCKING_SESSION_CAMERA_PROVIDER_H
37 #define _ARGUS_BLOCKING_SESSION_CAMERA_PROVIDER_H
38
39 namespace Argus
40 {
41
42 /**
43 * Adds a interface to camera provider to create a blocking capture session.
44 * It introduces two new interface:
45 * - Ext::IBlockingSessionCameraProvider: creates blocking capture session.
46 *
47 * @defgroup ArgusExtBlockingSessionCameraProvider Ext::BlockingSessionCameraProvider
48 * @ingroup ArgusExtensions
49 */
50 DEFINE_UUID(ExtensionName, EXT_BLOCKING_SESSION_CAMERA_PROVIDER, 1fff5f04,2ea9,4558,8e92,c2,4b,0b,82,b9,af);
51
52
53 namespace Ext
54 {
55
56 /**
57 * @class IBlockingSessionCameraProvider
58 *
59 * Interface used to create blocking capture session
60 *
61 * @ingroup ArgusCameraProvider ArgusExtBlockingSessionCameraProvider
62 */
63 DEFINE_UUID(InterfaceID, IID_BLOCKING_SESSION_CAMERA_PROVIDER, 3122fe85,b4cc,4945,af5d,a3,86,26,75,eb,a4);
64 class IBlockingSessionCameraProvider : public Interface
65 {
66 public:
67 static const InterfaceID& id() { return IID_BLOCKING_SESSION_CAMERA_PROVIDER; }
68
69 /**
70 * Creates and returns a blocking CaptureSession using the given device.
71 * For blocking CaptureSession, the capture related API call will block wait until the request
72 * is serviced by underlying driver. This will help timing control in client side
73 * when client auto control is involved.
74 * In compare, for the default CaptureSession, the capture related API call will put
75 * the request in a internal queue and return immediately, without blocking client thread.
76 * STATUS_UNAVAILABLE will be placed into @c status if the device is already in use.
77 * @param[in] device The device to use for the CaptureSession.
78 * @param[out] status Optional pointer to return success/status of the call.
79 * @returns The new CaptureSession, or NULL if an error occurred.
80 */
81 virtual CaptureSession* createBlockingCaptureSession(CameraDevice* device,
82 Status* status = NULL) = 0;
83
84 /**
85 * Creates and returns a blocking CaptureSession using the given device.
86 * For blocking CaptureSession, the capture related API call will block wait until the request
87 * is serviced by underlying driver. This will help timing control in client side
88 * when client auto control is involved.
89 * STATUS_UNAVAILABLE will be placed into @c status if any of the devices are already in use.
90 * @param[in] devices The device(s) to use for the CaptureSession.
91 * @param[out] status Optional pointer to return success/status of the call.
92 * @returns The new CaptureSession, or NULL if an error occurred.
93 */
94 virtual CaptureSession* createBlockingCaptureSession(const std::vector<CameraDevice*>& devices,
95 Status* status = NULL) = 0;
96
97 protected:
98 ~IBlockingSessionCameraProvider() {}
99 };
100
101 } // namespace Ext
102
103 } // namespace Argus
104
105 #endif
106